
<?php

$allMemberPages_obj = DAP_MemberPages::loadByAction('loggedinmenu');
$diffLogged = 'N';
if(isset($allMemberPages_obj[0])){
    $id = $allMemberPages_obj[0]->id;
    $diffLoggedIndata = DAP_MemberPagesValues::loadByActionIdAndName($id,'diffLoggedInMenu');
    $logoutdata = DAP_MemberPagesValues::loadByActionIdAndName($id,'loggedOutMenu');
    $loggedindata = DAP_MemberPagesValues::loadByActionIdAndName($id,'loggedinmenu');
    
    $diffLogged = 'N';
    $loggedin = '';
    $logout = '';
    if(isset($diffLoggedIndata)){
        $diffLogged = $diffLoggedIndata->getValue();
    }

    if(isset($logoutdata)){
        $logout = $logoutdata->getValue();
    }
    
    if(isset($loggedindata)){
        $loggedin = $loggedindata->getValue();
    }    
}

$nav_menus  = wp_get_nav_menus();

echo DapMemberShowLoader();
?>

<div class="login-menu-section">
    <div class="col-sm-12">
    	<div class="login-menu-heading">
            <input type="hidden" value="<?= $id ?>" class="loggedInId">
    		<h3 class="login-menu--title"><i class="fa fa-cog" aria-hidden="true"></i>Logged-in Menu</h3>
    	</div>
    	
    	<div class="login-menu-card">
    		<label>Do you want to display different menus to your Logged-in and Logged-out members?</label>
    		<select class="form-control diffLoggedInMenu">
    			<option  <?= isset($diffLogged) && $diffLogged == 'N' ? 'selected' : '' ?> value="N">No</option>
    			<option  <?= isset($diffLogged) && $diffLogged == 'Y' ? 'selected' : '' ?> value="Y">Yes</option>
    		</select>
    	</div>

    	<div class="login-menu-card commonHideShowMenuOuter" style="display: <?= isset($diffLogged) && $diffLogged == 'Y' ? 'flex' : 'none' ?>">
    		<label>Select the menu you want to display to logged-in members</label>
    		<select class="form-control selectLoggedInMenu">
                <option value="">Select Menu</option>
    			<?php 
    			foreach($nav_menus as $menu){
                    $selected = '';
                    if(isset($loggedin) && $loggedin == $menu->term_id){
                        $selected = 'selected';
                    }
                    echo '<option '.$selected.' value="'.$menu->term_id.'">'.$menu->name.'</option>';
    			}
    			?>
    			
    		</select>
    	</div>
    	
    	<div class="login-menu-card commonHideShowMenuOuter"  style="display: <?= isset($diffLogged) && $diffLogged == 'Y' ? 'flex' : 'none' ?>">
    		<label>Select the menu you want to display to logged-out members</label>
    		<select class="form-control selectLoggedOutMenu">
                <option value="">Select Menu</option>
    			<?php 
                
                foreach($nav_menus as $menu){
                    $selected = '';
                    if(isset($logout) && $logout == $menu->term_id){
                        $selected = 'selected';
                    }
                    echo '<option '.$selected.'  value="'.$menu->term_id.'">'.$menu->name.'</option>';
                }
                ?>
    		</select>
    	</div>

        
        <div class="info-div1 commonNotificationShowHide">
            <p class="loggedInMenuNotification"></p>
        </div>

        <div class="info-div2 commonNotificationShowHide">
            <p class="loggedInfoNotification"></p>
        </div>

        <div class="info-div commonNotificationShowHide">
            <p class="loggedSavedSuccess"></p>
        </div>
        
    	<div class="login-menu-actions col-sm-5" style="justify-content: center;width:70%">
    		<button class="btn btn-primary saveDiffLoggedInMenu">Save</button>
    	</div>
    </div>	
</div>  
